using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace DiskCatalog {
	public partial class Form1 : Form {
		static long kilo = 1024;
		string catalogFile = @"";
		Catalog catalog;
		bool inInitializing = false;
		FileSystemWatcher watcher = new FileSystemWatcher();
		bool changed = false;

		public static void log( string s ) {
//			Console.WriteLine( s );
		}

		public static void print( string s ) {
//			Console.WriteLine( s );
		}

		public static void error( string s ) {
//			Console.Error.WriteLine( s );
		}

		public static string sizeFold( long size ) {
//			string[] unit = { "Bytes", "KiB", "MiB", "GiB", "TiB" };
			string[] unit = { "Bytes", "KB", "MB", "GB", "TB" };
			int unitIndex = 0;
			double res = (double)size;

			for( unitIndex = 0; unitIndex < unit.Length; unitIndex++ ) {
				if( res < kilo ) {
					break;
				}
				res /= (double)kilo;
			}
			string ress = string.Format( ( ( unitIndex == 0 ) ? "{0:N0}" : "{0:N2}" ), res ) + unit[ unitIndex ];
			//			log( "sizeFold: " + string.Format( "{0:N0}", size ) + "" + ress + "łB" );
			return ress;
		}

		// XMLǂ
		static Object loadXML( string filename, Type T ) {
			System.Xml.Serialization.XmlSerializer serializer =
				new System.Xml.Serialization.XmlSerializer( T );

			System.IO.FileStream fs = new System.IO.FileStream( filename, System.IO.FileMode.Open );
			Object var = serializer.Deserialize( fs );
			fs.Close();
			//			log("<" + filename + ">ǂݍ݂܂B");
			return var;
		}

		// XML
		static void saveXML( string filename, Object var ) {
			System.Xml.Serialization.XmlSerializer serializer =
				new System.Xml.Serialization.XmlSerializer( var.GetType() );
			System.IO.FileStream fs = new System.IO.FileStream( filename, System.IO.FileMode.Create );
			serializer.Serialize( fs, var );
			fs.Close();
			//			log("<" + filename + ">ۑ܂B");
		}

		static SizeF updateBounds( SizeF last, SizeF newer ) {
			if( last.Width < newer.Width ) {
				last.Width = newer.Width;
			}
			if( last.Height < newer.Height ) {
				last.Height = newer.Height;
			}
			return last;
		}

		public Form1() {
			InitializeComponent();

			/* ܂ĎłȂBȂ|[OقB
			watcher.Path = ".";	// @"";
			watcher.Filter = catalogFile;	// "*.*";
			watcher.IncludeSubdirectories = true;
			watcher.NotifyFilter = NotifyFilters.LastWrite;
			watcher.Created += new FileSystemEventHandler( catalogChanged );
			watcher.SynchronizingObject = this;

			watcher.EnableRaisingEvents = true;
			*/
			string[] args = Environment.GetCommandLineArgs();

			if( args.Length > 1 ) {
				catalogFile = args[ 1 ];
			}
			inInitializing = true;
			load();
			inInitializing = false;
		}
		/*
		static void catalogChanged( object source, FileSystemEventArgs e ) {
			Type t = source.GetType();

			int i = 1;
		}
		*/
		void load() {
			try {
				catalog = (Catalog)loadXML( catalogFile, typeof( Catalog ) );
				this.Text = "DiskCatalog - " + catalogFile;
				button4.Enabled = true;
			} catch( Exception ) {
				catalogFile = "";
				this.Text = "DiskCatalog - " + "Untitled";
				catalog = new Catalog( this.Size );
				changed = false;
//				save();
			}
//			this.Location = catalog.position.Location;
			this.Size = catalog.windowSize;

			treeView1.Nodes.Clear();
			foreach( CatalogEntityListItem listitem in catalog.list ) {
				treeView1.Nodes.Add( listitem.root.apply( this, new TreeNode(), listitem.capacity ) );
			}
		}

		void save() {
			catalog.windowSize = this.Size;
			catalog.lastModified = DateTime.Now;
			if( catalogFile.Length > 0 ) {
				saveXML( catalogFile, catalog );
				changed = false;
			} else {
				changed = true;
			}
		}

		void add( string path ) {
			string fullpath = Path.GetFullPath( path );
			DirectoryInfo root = new DirectoryInfo( fullpath );
			CatalogEntity cata = new CatalogEntity( root );

			long capa = 0;
			if( ( fullpath.Length == 3 ) && ( fullpath[ 1 ] == ':' ) ) {
				capa = ( new DriveInfo( fullpath[ 0 ].ToString() ).TotalSize );
			}
			catalog.add( cata, capa );
			treeView1.Nodes.Add( cata.apply( this, new TreeNode(), capa ) );
			save();
		}

		private void treeView1_DragDrop( object sender, DragEventArgs e ) {
			IDataObject data = e.Data;
			string t = data.GetType().ToString();
			string s = data.ToString();

			string[] drags = (string[])e.Data.GetData( DataFormats.FileDrop );

			foreach( string d in drags ) {
				/*
				if( !System.IO.File.Exists( d ) ) {
					// t@CȊOł΃CxgEnh𔲂
					return;
				}
				*/
				if( !System.IO.Directory.Exists( d ) ) {
					return;
				}

				add( d );
			}
			e.Effect = DragDropEffects.Copy;

		}

		/*
		private void treeView1_ItemDrag( object sender, ItemDragEventArgs e ) {
			// ͎hbOƂɌĂ΂
			Object data = e.Item;
			string t = data.GetType().ToString();
			string s = data.ToString();
			
			treeView1.DoDragDrop( e.Item, DragDropEffects.All );
		}
		*/

		private void treeView1_DragEnter( object sender, DragEventArgs e ) {
			IDataObject data = e.Data;
			string t = data.GetType().ToString();
			string s = data.ToString();

			// ܂Ńhbvł邩ǂ߂̂ł
			if( e.Data.GetDataPresent( DataFormats.FileDrop ) ) {
				e.Effect = DragDropEffects.Copy;
			}

		}

		/*
		private void treeView1_KeyPress( object sender, KeyPressEventArgs e ) {
			// ͕ʂ̕
			char k = e.KeyChar;

//			if( k == 
			e.Handled = false;
		}
		*/

		private void treeView1_KeyUp( object sender, KeyEventArgs e ) {
			Keys kc = e.KeyCode;
			Keys kd = e.KeyData;
			int kv = e.KeyValue;
			Keys ks = e.Modifiers;

			switch( kc ) {
			case Keys.Delete:
				TreeNode node = treeView1.SelectedNode;
				TreeNode parent = node.Parent;
				CatalogEntity entity = (CatalogEntity)node.Tag;

				if( parent == null ) {
					catalog.list.Remove( catalog.list[ treeView1.Nodes.IndexOf( node ) ] );
					treeView1.Nodes.Remove( node );
				} else {
					( (CatalogEntity)parent.Tag ).subdirs.Remove( entity );
					parent.Nodes.Remove( node );
				}
				save();
				break;
			}

			e.Handled = false;
		}

		private void button1_Click( object sender, EventArgs e ) {
			MessageBox.Show( "܂AłB" );
		}

		private void Form1_SizeChanged( object sender, EventArgs e ) {
			if( !inInitializing ) {
				save();
			}
		}

		private void Form1_Move( object sender, EventArgs e ) {
			if( !inInitializing ) {
				save();
			}
		}

		private void treeView1_AfterSelect( object sender, TreeViewEventArgs e ) {
			// treeI
			listView1.BeginUpdate();
			listView1.Clear();
			if( ( (CatalogEntity)e.Node.Tag ).files.Count > 0 ) {
				listView1.Columns.Add( "" );
				listView1.Columns.Add( "TCY" );
				listView1.Columns.Add( "XV" );

				listView1.Columns[ 1 ].TextAlign = HorizontalAlignment.Right;
				foreach( CatalogEntity entity in ( (CatalogEntity)e.Node.Tag ).files ) {
					ListViewItem li = new ListViewItem( entity.name );
					li.SubItems.Add( string.Format( "{0:N0}", entity.size ) );
					li.SubItems.Add( entity.lastModified.ToString() );
					listView1.Items.Add( li );
				}
				listView1.AutoResizeColumns( ColumnHeaderAutoResizeStyle.ColumnContent );
			}
			listView1.EndUpdate();
		}

		private void button4_Click( object sender, EventArgs e ) {
			load();
		}

		private void button2_Click( object sender, EventArgs e ) {
			DialogResult res = openFileDialog1.ShowDialog();

			if( res == DialogResult.OK ) {
				catalogFile = openFileDialog1.FileName;
				load();
			}
		}

		private void button3_Click( object sender, EventArgs e ) {
			DialogResult res = saveFileDialog1.ShowDialog();
			
			if( res == DialogResult.OK ) {
				catalogFile = saveFileDialog1.FileName;
				save();
				this.Text = "DiskCatalog - " + catalogFile;
			}
		}

		private void Form1_FormClosing( object sender, FormClosingEventArgs e ) {
			switch( e.CloseReason ) {
			case CloseReason.WindowsShutDown:		// OS̃Vbg_Eɂ
				break;
			case CloseReason.ApplicationExitCall:	// Application.Exitɂ
			case CloseReason.FormOwnerClosing:		// L̃tH[悤ƂĂ
			case CloseReason.MdiFormClosing:		// MDI̐etH[悤ƂĂ
			case CloseReason.TaskManagerClosing:	// ^XN}l[Wɂ
			case CloseReason.UserClosing:			// [U[C^[tFCXɂ
			case CloseReason.None:
			default:
				if( changed && ( catalogFile.Length == 0 ) ) {
					DialogResult res = MessageBox.Show( "J^Oۑ܂H", "I", MessageBoxButtons.YesNoCancel );
					switch( res ) {
					case DialogResult.Yes:
						res = saveFileDialog1.ShowDialog();

						if( res == DialogResult.OK ) {
							catalogFile = saveFileDialog1.FileName;
							save();
						}
						break;
					case DialogResult.No:
						break;
					case DialogResult.Cancel:
						e.Cancel = true;
						break;
					}
				}
				break;
			}

		}

	}

	public class CatalogEntity {
		public string name;
		public DateTime lastModified;
		public long size;
		public List<CatalogEntity> subdirs = new List<CatalogEntity>();
		public List<CatalogEntity> files = new List<CatalogEntity>();
		public int level = 0;
		public string path;

		public CatalogEntity() {
		}
		public CatalogEntity( string name, DateTime lastModified, long size ) {
			this.name = name;
			this.lastModified = lastModified;
			this.size = size;
		}

		public CatalogEntity( string rootPath ) : this( new DirectoryInfo( rootPath ) ) {
			path = Path.GetFullPath( rootPath );

			if( ( path.Length == 3 ) && ( path[ 1 ] == ':' ) ) {
				// [gfBNĝƂ̓{[ɂ
				DriveInfo di = new DriveInfo( path[ 0 ].ToString() );

				if( !di.VolumeLabel.Equals( "" ) ) {
					this.name = "Volume \"" + di.VolumeLabel + "\"";
				}
			}
		}

		public CatalogEntity( FileInfo fi ) {
			this.name = fi.Name;
			this.lastModified = fi.LastWriteTime;
			this.size = fi.Length;
		}

		public CatalogEntity( DirectoryInfo dInfo ) {
			this.name = dInfo.Name;
			this.lastModified = dInfo.LastWriteTime;

			DirectoryInfo[] dis = dInfo.GetDirectories();

			foreach( DirectoryInfo di in dis ) {
				try {
					CatalogEntity ce = new CatalogEntity( di );
					ce.level = this.level + 1;
					subdirs.Add( ce );
					this.size += ce.size;
				} catch( System.UnauthorizedAccessException e ) {
					Form1.error( "ANZXs\F" + e.Message );
				}
			}

			FileInfo[] fis = dInfo.GetFiles();

			foreach( FileInfo fi in fis ) {
				try {
					CatalogEntity ce = new CatalogEntity( fi );
//					ce.level = -1;
					files.Add( ce );
					this.size += ce.size;
				} catch( System.UnauthorizedAccessException e ) {
					Form1.error( "ANZXs\F" + e.Message );
				}
			}
		}

		public TreeNode apply( Form1 form, TreeNode node, long capacity ) {
//			this.node = node;
			node.Tag = this;
			string capastr = ( capacity > 0 ) ? "/" + Form1.sizeFold( capacity ) : "";
			node.Text = this.name + " (" + Form1.sizeFold( size ) + capastr + ")";

			foreach( CatalogEntity dir in subdirs ) {
				TreeNode newnode = new TreeNode();

//				ContextMenu menu = newnode.ContextMenu();
//				newnode.ContextMenu = form.conte;


				dir.apply( form, newnode, 0 );
				node.Nodes.Add( newnode );
			}
			return node;
		}

	}

	public class CatalogEntityListItem {
		public CatalogEntity root;
		public long capacity;

		public CatalogEntityListItem() {
		}
		public CatalogEntityListItem( CatalogEntity root, long capacity ) {
			this.root = root;
			this.capacity = capacity;
		}
	}

	public class Catalog {
		public DateTime lastModified;
		public Size windowSize;
		public List<CatalogEntityListItem> list;

		public Catalog() {
		}
		public Catalog( Size windowSize ) {
			lastModified = new DateTime( 0 );
			this.windowSize = windowSize;
			list = new List<CatalogEntityListItem>();
		}
		public void add( CatalogEntity root, long capacity ) {
			list.Add( new CatalogEntityListItem( root, capacity ) );
		}

	}
}