using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace LowWatermark {
	class Program {
		static long kilo = 1024;

		static void log( string s ) {
			Console.WriteLine( s );
		}

		static void print( string s ) {
			Console.WriteLine( s );
		}

		static void error( string s ) {
			Console.Error.WriteLine( s );
		}

		static void usage() {
			print( "usage: LowWatermark [-t] ce 폜ΏۃfBNg" );
			print( "    -t eXg[hBۂ̍폜͍s܂B" );
			print( "    ceʂ100MƂ̒P(K,M,G,T)Ŏwł܂(̂)B" );
			print( "    TufBNg̃t@C͍폜܂B" );
		}

		static long decodeWM( string s ) {
			long val = 0;

			foreach( char c in s ) {
				if( ( c >= '0' ) && ( c <= '9' ) ) {
					val = val * 10 + ( c - '0' );
				} else {
					switch( Char.ToLower( c ) ) {
					case 'k':	val *= kilo;						break;
					case 'm':	val *= kilo * kilo;					break;
					case 'g':	val *= kilo * kilo * kilo;			break;
					case 't':	val *= kilo * kilo * kilo * kilo;	break;
					}
					break;
				}
			}
//			log( "decodeWM: " + s + "" + string.Format( "{0:N0}", val ) + "łB" );
			return val;
		}

		static string sizeFold( long size ) {
//			string[] unit = { "Bytes", "KiB", "MiB", "GiB", "TiB" };
			string[] unit = { "Bytes", "KB", "MB", "GB", "TB" };
			int unitIndex = 0;
			double res = (double)size;

			for( unitIndex = 0; unitIndex < unit.Length; unitIndex++ ) {
				if( res < kilo ) {
					break;
				}
				res /= (double)kilo;
			}
			string ress = string.Format( ( ( unitIndex == 0 ) ? "{0:N0}" : "{0:N2}" ), res ) + unit[ unitIndex ];
//			log( "sizeFold: " + string.Format( "{0:N0}", size ) + "" + ress + "łB" );
			return ress;
		}

		static void Main( string[] args ) {
			bool testmode = false;
			int ac = 0;

			for( ac = 0; ac < args.Length; ac++ ) {
				if( args[ ac ].Equals( "-t", StringComparison.CurrentCultureIgnoreCase ) ) {
					testmode = true;
					continue;
				}
				break;
			}
			if( ( args.Length - ac ) < 2 ) {
				usage();
				return;
			}
			long keepsize = decodeWM( args[ ac + 0 ] );
			string fullpath = Path.GetFullPath( args[ ac + 1 ] );

			if( !Directory.Exists( fullpath ) ) {
				error( fullpath + "̓fBNgł͂܂B" );
				return;
			}
			if( fullpath[ 1 ] != ':' ) {
				error( "hCu߂܂B" );
				return;
			}
			string drive = Char.ToUpper( fullpath[ 0 ] ).ToString();

			DriveInfo dri = new DriveInfo( drive );
			DirectoryInfo diri = new DirectoryInfo( fullpath );
			FileInfo[] fi = diri.GetFiles();

			// ÂɃ\[g
			Array.Sort( fi, new FileLastWriteTimeComparer() );

			// 邩ȂȂ܂ŏ
			long freesize = dri.AvailableFreeSpace;
			long erasedsize = 0;
			int erasedCount = 0;
			print( "폜ΏۃpX<" + fullpath + "> : mۖڕW <" + sizeFold( keepsize ) + ">" );

			foreach( FileInfo f in fi ) {
				if( keepsize > freesize ) {
//					log( "폜ׂeʁF" + sizeFold( oversize ) );
					print( "" + f.Name + "(" + sizeFold( f.Length ) + ")폜܂B" );
					if( !testmode ) {
						f.Delete();
					}
					freesize += f.Length;
					erasedsize += f.Length;
					erasedCount++;
				}

			}
			if( erasedCount > 0 ) {
				print(
					"" + erasedCount + "̃t@C(" + sizeFold( erasedsize ) + ")폜A" +
					sizeFold( dri.TotalSize ) + "" + sizeFold( dri.AvailableFreeSpace ) + "󂫂܂B"
				);
			} else {
				print(
					"" + sizeFold( dri.TotalSize ) + "" + sizeFold( dri.AvailableFreeSpace ) + "󂢂Ă܂B"
				);
			}
//			log( drive + ":̗̈TCYF" + sizeFold( dri.TotalSize ) );
//			log( drive + ":̋󂫗eʁF" + sizeFold( dri.TotalFreeSpace ) );
//			print( drive + ":̌݃[U[̋󂫗eʁF" + sizeFold( dri.AvailableFreeSpace ) );
			
		}
	}
	public class FileLastWriteTimeComparer : IComparer<FileInfo> {
		public int Compare( FileInfo x, FileInfo y ) {
			long tdiff = x.LastWriteTime.Ticks - y.LastWriteTime.Ticks;
			if( tdiff == 0 ) {
				return 0;
			}
			if( tdiff > 0 ) {
				return 1;
			}
			return -1;
		}
	}
}
