using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace OldDel {
	class Program {
		static long kilo = 1024;
		static long secOfTicks = 10000000L;
		static long minOfTicks = secOfTicks * 60L;
		static long hourOfTicks = minOfTicks * 60L;
		static long dayOfTicks = hourOfTicks * 24L;
		static void log( string s ) {
			Console.WriteLine( s );
		}

		static void print( string s ) {
			Console.WriteLine( s );
		}

		static void error( string s ) {
			Console.Error.WriteLine( s );
		}

		static string sizeFold( long size ) {
//			string[] unit = { "Bytes", "KiB", "MiB", "GiB", "TiB" };
			string[] unit = { "Bytes", "KB", "MB", "GB", "TB" };
			int unitIndex = 0;
			double res = (double)size;

			for( unitIndex = 0; unitIndex < unit.Length; unitIndex++ ) {
				if( res < kilo ) {
					break;
				}
				res /= (double)kilo;
			}
			string ress = string.Format( ( ( unitIndex == 0 ) ? "{0:N0}" : "{0:N2}" ), res ) + unit[ unitIndex ];
			//			log( "sizeFold: " + string.Format( "{0:N0}", size ) + "" + ress + "łB" );
			return ress;
		}

		static void usage() {
			print( "usage: OldDel [-t] [-d oߓ] [-f 폜t@Cp^[] 폜ΏۃfBNg" );
			print( "  -t eXg[hBۂ̍폜͍s܂B" );
			print( "  -d 㑱̃t@Cp^[Ƀ}b`t@ĈAw肳ꂽô폜܂B" );
			print( "     p^[ƂɈقȂoߓw肵ꍇ͂ꂼ̃p^[̑OɎw肵ĂB" );
			print( "     ȗ0w肵Ƃ݂Ȃ܂B܂A̎Z͓tł͂ȂAݎƃt@C" );
			print( "     ŏIC̍bPʂŔr܂B" );
			print( "  -f 폜t@CɃ}b`郏ChJ[hp^[łBw肷Ƃ͂ꂼ-f" );
			print( "     ĂBȗƂׂ(*.*)w肵Ƃ݂Ȃ܂B" );
			print( "  ̃R}h̓TufBNg̃t@C͍폜܂B" );
		}

		static void Main( string[] args ) {
			bool testmode = false;
			List<DeletePattern> patterns = new List<DeletePattern>();
			int ac = 0;
			string fullpath;
			long now = DateTime.Now.Ticks;

			try {
				long pastForDel = 0;

				for( ac = 0; ac < args.Length; ac++ ) {
					if( args[ ac ].Equals( "-d", StringComparison.CurrentCultureIgnoreCase ) ) {
						pastForDel = long.Parse( args[ ++ac ] );
						continue;
					}
					if( args[ ac ].Equals( "-t", StringComparison.CurrentCultureIgnoreCase ) ) {
						testmode = true;
						continue;
					}
					if( args[ ac ].Equals( "-f", StringComparison.CurrentCultureIgnoreCase ) ) {
						patterns.Add( new DeletePattern( args[ ++ac ], pastForDel ) );
						continue;
					}
					break;
				}
				if( ( args.Length - ac ) < 1 ) {
					usage();
					return;
				}
				fullpath = Path.GetFullPath( args[ ac ] );
				if( patterns.Count == 0 ) {
					patterns.Add( new DeletePattern( "*.*", pastForDel ) );
				}
			} catch( Exception ) {
				usage();
				return;
			}

			if( !Directory.Exists( fullpath ) ) {
				error( args[ ac + 1 ] + "̓fBNgł͂܂B" );
				return;
			}
			DirectoryInfo diri = new DirectoryInfo( fullpath );
			int erasedCount = 0;
			long erasedsize = 0;

			foreach( DeletePattern pat in patterns ) {
				FileInfo[] fi = diri.GetFiles( pat.s );

				foreach( FileInfo f in fi ) {
					long pastOfFileT = now - f.LastWriteTime.Ticks;
					long pastOfFile = pastOfFileT / dayOfTicks;
					/*
					log( "f.LastWriteTime.Ticks: " + f.LastWriteTime.Ticks );
					log( ": " + ( ( f.LastWriteTime.Ticks - delLimit ) / 10000 ) + "b" );
					*/
					if( pastOfFile >= pat.d ) {
						string paststr = "";

						if( pastOfFileT >= dayOfTicks ) {
							paststr = "" + pastOfFile + "O";
						} else if( pastOfFileT >= hourOfTicks ) {
							paststr = "" + ( pastOfFileT / hourOfTicks ) + "ԑO";
						} else if( pastOfFileT >= minOfTicks ) {
							paststr = "" + ( pastOfFileT / minOfTicks ) + "O";
						} else {
							paststr = "" + ( pastOfFileT / secOfTicks ) + "bO";
						}

						print( "" + f.Name + " (" + paststr + ") 폜܂B" );
						if( !testmode ) {
							f.Delete();
						}
						erasedCount++;
						erasedsize += f.Length;
					}

				}
			}
			if( fullpath[ 1 ] != ':' ) {
				if( erasedCount > 0 ) {
					print( "" + erasedCount + "̃t@C(" + sizeFold( erasedsize ) + ")폜܂B" );
				}
			} else {
				DriveInfo dri = new DriveInfo( fullpath[ 0 ].ToString() );
				if( erasedCount > 0 ) {
					print(
						"" + erasedCount + "̃t@C(" + sizeFold( erasedsize ) + ")폜A" +
						sizeFold( dri.TotalSize ) + "" + sizeFold( dri.AvailableFreeSpace ) + "󂫂܂B"
					);
				} else {
					print(
						"" + sizeFold( dri.TotalSize ) + "" + sizeFold( dri.AvailableFreeSpace ) + "󂢂Ă܂B"
					);
				}
			}
		}
	}
	public class DeletePattern {
		public string s;
		public long d;

		public DeletePattern( string s, long d ) {
			this.s = s;
			this.d = d;
		}
	}
}
